/*
 * Copyright (c) IntellectualCrafters - 2014.
 * You are not allowed to distribute and/or monetize any of our intellectual property.
 * IntellectualCrafters is not affiliated with Mojang AB. Minecraft is a trademark of Mojang AB.
 *
 * >> File = PlayerClaimPlotEvent.java
 * >> Generated by: Citymonstret at 2014-08-09 15:21
 */

package com.intellectualcrafters.plot.events;

import java.util.Set;

import org.bukkit.entity.Player;
import org.bukkit.event.Cancellable;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.bukkit.event.player.PlayerEvent;

import com.intellectualcrafters.plot.Plot;

/**
 * Created by Citymonstret on 2014-08-09.
 */
public class PlotMergeEvent extends Event implements Cancellable {
    private static HandlerList handlers = new HandlerList();
    private boolean cancelled;

    private Set<Plot> plots;

    /**
     * PlotMergeEvent: Called when a plot is merged
     * @param player
     * @param plot
     */
    public PlotMergeEvent(Set<Plot> plots) {
        this.plots = plots;
    }
    
    /**
     * Get the plots involved
     * @return Plot
     */
    public Set<Plot> getPlost() {
        return this.plots;
    }

    public static HandlerList getHandlerList() {
        return handlers;
    }

    @Override
    public HandlerList getHandlers() {
        return handlers;
    }

    @Override
    public boolean isCancelled() {
        return this.cancelled;
    }

    @Override
    public void setCancelled(boolean b) {
        this.cancelled = b;
    }
}
